!= Module DebugSet
!
! Authors::   ODAKA Masatsugu, SUGIYAMA Ko-ichiro
! Version::   $Id: debugset.f90,v 1.4 2010-08-13 07:18:16 sugiyama Exp $
! Tag Name::  $Name: arare4-20110318 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥХ⥸塼
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!

module debugset
  !
  !ǥХ⥸塼
  !

  !⥸塼ɤ߹
  use dc_trace,   only: SetDebug

  !ۤηػ
  implicit none

  ! °
  public DebugOn, cpurank

  !ѿ
  logical :: DebugOn       ! ǥХåϥå
  integer :: cpurank = 0   ! CPU ֹ

  ! save
  save DebugOn, cpurank  

contains

  subroutine debugset_init(cfgfile, myrank)
    !
    !NAMELIST , ǥХåϥåؤԤ.
    !

    !⥸塼ɤ߹
    use dc_message,    only: MessageNotify

    !ۤηػ
    implicit none

    !ѿ
    character(*), intent(in)      :: cfgfile
    integer, intent(in), optional :: myrank
    
    !NAMELIST 
    NAMELIST /debugset/ DebugOn
    
    open (10, FILE=cfgfile)
    read(10, NML=debugset)
    close(10)

    !ǥХå⡼ɤʤ dc_trace  ON ˤ
    if ( DebugOn ) call SetDebug

    if (present(myrank)) then 
      cpurank = myrank 
    end if
    
  end subroutine debugset_init
  
end module debugset
